// generate random test data for svmtl testing

#include <iostream>

int main( int argc, char** argv)
{
  unsigned int nClasses = 10;
  unsigned int nFeatureVectorsPerClass = 100;
  unsigned int nComponents = 100;
  
  // create random feature vectors
  for( unsigned int i = 0; i < nFeatureVectorsPerClass*nClasses; ++i)
  {
    int label = i % nClasses;
    std::cout << label;
    std::cout << " " << label*0.9 + double(std::rand())/RAND_MAX;  // in feature 0 all
                                                        // classes are
                                                        // well
                                                        // separated 
    for( unsigned int j = 1; j < nComponents; ++j)
    {
      std::cout << " " << double(std::rand())/RAND_MAX;
    }
    std::cout << std::endl;
    
  }
}
