//
//  test how to implement a Model typedef into the SVM without knowing
//  the feature vecotor type 
//

#include <iostream>
#include <vector>

template<typename FV>
class MyModel
{
public:
  const char* name()
        {
          return "MyModel";
        }
};



class MySVM
{
public:
  
  template<typename FV>
  struct Traits
  {
    typedef MyModel<FV> ModelType;
  };
  
  template<typename FV>
  void train( FV featureVecotors, MyModel<FV>& resultingModel)
        {
          std::cout << "model is " << resultingModel.name() << std::endl;
        }
  

};


template< typename SVM>
void useSVM()
{
  // create SVM
  SVM svm;
  // create the approprite Model
  typename SVM::Traits<std::vector<int> >::ModelType model;
  
  // create FeatureVector
  std::vector<int> fv;
  svm.train( fv, model);
  
}


int main( int argc, char** argv)
{
  useSVM<MySVM>();
  return 0;

}

  
