#include <iostream>
#include <sstream>
#include <string>

int main( void)
{
  std::string a = "1234.567 ,123.234 ";
  std::istringstream iss(a);
  double ad;
  std::cout << "before reading\n";
  std::cout << "iss.good() = " << iss.good() << std::endl;
  std::cout << "iss.eof() = " << iss.good() << std::endl;
  std::cout << "stream position: " << iss.tellg() << std::endl;
  std::cout << "stream state as bool " << bool(iss) << std::endl<< std::endl;
  iss >> ad >> std::ws;
  std::cout << "read " << ad << "\n";
  std::cout << "iss.good() = " << iss.good() << std::endl;
  std::cout << "iss.eof() = " << iss.good() << std::endl;
  std::cout << "stream position: " << iss.tellg() << std::endl;
  std::cout << "stream state as bool " << bool(iss) << std::endl<< std::endl;
  iss >> ad>> std::ws;
  std::cout << "read " << ad << "\n";
  std::cout << "iss.good() = " << iss.good() << std::endl;
  std::cout << "iss.eof() = " << iss.good() << std::endl;
  std::cout << "stream position: " << iss.tellg() << std::endl;
  std::cout << "stream state as bool " << bool(iss) << std::endl<< std::endl;
  
  iss >> ad>> std::ws;
  std::cout << "read " << ad << "\n";
  std::cout << "iss.good() = " << iss.good() << std::endl;
  std::cout << "iss.eof() = " << iss.good() << std::endl;
  std::cout << "stream position: " << iss.tellg() << std::endl;
  std::cout << "stream state as bool " << bool(iss) << std::endl<< std::endl;
  
  
  std::string b = "     ";
  std::istringstream issb(b);
  do
  {
    int c;
    c = issb.rdbuf()->sgetc();
    std::cout << "got '" << c << "'\n";
    std::cout << "issb.good() = " << issb.good() << std::endl;
    std::cout << "issb.eof() = " << issb.good() << std::endl;
    std::cout << "stream position: " << issb.tellg() << std::endl;
    std::cout << "stream state as bool " << bool(issb) << std::endl<< std::endl;
    char c2;
    issb.get(c2);
    std::cout << "got '" << c2 << "'\n";
    std::cout << "issb.good() = " << issb.good() << std::endl;
    std::cout << "issb.eof() = " << issb.good() << std::endl;
    std::cout << "stream position: " << issb.tellg() << std::endl;
    std::cout << "stream state as bool " << bool(issb) << std::endl<< std::endl;
  } while (issb);
  
  std::string c = "     ";
  std::istringstream issc(c);
  std::cout << "does std::ws also kill the stream?\n";
  issc >> std::ws;
  std::cout << "issc.good() = " << issc.good() << std::endl;
  std::cout << "issc.eof() = " << issc.good() << std::endl;
  std::cout << "stream position: " << issc.tellg() << std::endl;
  std::cout << "stream state as bool " << bool(issc) << std::endl<< std::endl;  
      


  return 0;
}
