/**************************************************************************
**       Title: svmtl command line application frp NetCDF files
**    $RCSfile: svmtl_nc.cc,v $
**   $Revision: 1.2 $$Name:  $
**       $Date: 2004/08/26 13:50:54 $
**   Copyright: GPL $Author: ronneber $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: svmtl_nc.cc,v $
**  Revision 1.2  2004/08/26 13:50:54  ronneber
**  *** empty log message ***
**
**  Revision 1.1  2004/08/26 08:36:59  ronneber
**  initital import
**
**
**
**
**************************************************************************/


#include <SVMApplication.hh>
#include <TList.hh>
#include <DefaultMultiClassList.hh>
#include <DefaultTwoClassList.hh>
#include <DefaultOneClassList.hh>
#include <DefaultKernelList.hh>
#include <AlgorithmLists.hh>
#include <BasicFV.hh>
#include <LoadSaveNetCDF.hh>

typedef svt::SVMApplication< svt::BasicFV,
                             svt::AlgorithmLists< svt::DefaultMultiClassList, 
                                                  svt::DefaultTwoClassList,
                                                  svt::DefaultOneClassList,
                                                  svt::DefaultKernelList>,
                             svt::LoadSaveNetCDF> SVMApplicationNetCDF;


int main( int argc, const char** argv)
{
  
  SVMApplicationNetCDF sa;
  return sa.main( argc, argv, std::cout);
}

