/**************************************************************************
**       Title: 
**    $RCSfile: DefaultKernelList.hh,v $
**   $Revision: 1.2 $$Name:  $
**       $Date: 2004/09/03 07:06:59 $
**   Copyright: GPL $Author: ronneber $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: DefaultKernelList.hh,v $
**  Revision 1.2  2004/09/03 07:06:59  ronneber
**  - Added Kernel_SCALE for feature vector scaling
**
**  Revision 1.1  2004/08/26 08:36:58  ronneber
**  initital import
**
**
**
**************************************************************************/
#ifndef DEFAULTKERNELLIST_HH
#define DEFAULTKERNELLIST_HH

#include "TList.hh"
#include "Kernel_LINEAR.hh"
#include "Kernel_RBF.hh"
#include "Kernel_POLY.hh"
#include "Kernel_SIGMOID.hh"
#include "Kernel_MATRIX.hh"
#include "Kernel_SCALE.hh"

namespace svt
{
  /*-------------------------------------------------------------------------
   *  specify kernel functions
   *-------------------------------------------------------------------------*/
  typedef TLIST_12( 
      svt::Kernel_MATRIX< svt::Kernel_RBF>, 
      svt::Kernel_MATRIX< svt::Kernel_LINEAR>, 
      svt::Kernel_MATRIX< svt::Kernel_POLY>, 
      svt::Kernel_MATRIX< svt::Kernel_SIGMOID>,
      svt::Kernel_MATRIX< svt::Kernel_SCALE< svt::Kernel_RBF> >, 
      svt::Kernel_MATRIX< svt::Kernel_SCALE< svt::Kernel_LINEAR> >, 
      svt::Kernel_MATRIX< svt::Kernel_SCALE< svt::Kernel_POLY> >, 
      svt::Kernel_MATRIX< svt::Kernel_SCALE< svt::Kernel_SIGMOID> >,
      svt::Kernel_RBF, 
      svt::Kernel_LINEAR, 
      svt::Kernel_POLY, 
      svt::Kernel_SIGMOID ) DefaultKernelList;

}

#endif
