#include <map>
#include <string>
#include <iostream>

int main( int argc, char** argv)
{
  std::multimap<std::string, std::string> mymap;
  
  mymap.insert( std::make_pair( "hurz", "harz1"));
  mymap.insert( std::make_pair( "hurz", "harz3"));
  mymap.insert( std::make_pair( "hurz", "harz2"));
  mymap.insert( std::make_pair( "hurz", "harz3"));
  mymap.insert( std::make_pair( "schnurz", "piep"));
  for( std::multimap<std::string, std::string>::const_iterator 
           p = mymap.begin(); p != mymap.end(); ++p)
  {
    std::cout << p->first << ": " << p->second << std::endl;
  }

  // sort and remove duplicate entries (using slow bubble sort)
  bool completeFlag = false;
  while( !completeFlag)
  {
    completeFlag = true;
    std::multimap<std::string, std::string>::const_iterator p = mymap.begin();
    std::multimap<std::string, std::string>::const_iterator q = p;
    ++q;
    
    for( ; q != mymap.end(); ++p, ++q)
    {
      if( p->first == q->first)
      {
        if( p->second > q->second)
        {
          mymap.swap( *p,*q);
          completeFlag = false;
        }
      }
    }
  }
  
  std::cout << "sorted:\n";
  
  for( std::multimap<std::string, std::string>::const_iterator 
           p = mymap.begin(); p != mymap.end(); ++p)
  {
    std::cout << p->first << ": " << p->second << std::endl;
  }

        
  
  return 0;
}
