/**************************************************************************
**       Title: svmtl command line application
**    $RCSfile: svmtl_mini.cc,v $
**   $Revision: 1.2 $$Name:  $
**       $Date: 2005/03/29 18:06:29 $
**   Copyright: GPL $Author: ronneber $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: svmtl_mini.cc,v $
**  Revision 1.2  2005/03/29 18:06:29  ronneber
**  - cosmetic changes
**
**  Revision 1.1  2005/02/11 12:25:15  ronneber
**  - initial version
**
**
**
**************************************************************************/

#include <SVMApplication.hh>
#include <BasicFV.hh>
#include <AlgorithmLists.hh>
#include <DefaultMultiClassList.hh>
#include <DefaultTwoClassList.hh>
#include <DefaultOneClassList.hh>
#include <DefaultKernelList.hh>
#include <LoadSaveASCII.hh>


// minimalistic SVMApplication with only two kernels
//
typedef svt::SVMApplication< svt::BasicFV,
                             svt::AlgorithmLists< 
    TTLIST_1(svt::MultiClassSVMOneVsOne),
    TTLIST_1(svt::TwoClassSVMc),
    svt::DefaultOneClassList,
    TLIST_2(  svt::Kernel_MATRIX< svt::Kernel_SCALE< svt::Kernel_RBF> >,
              svt::Kernel_SCALE< svt::Kernel_RBF>)>,
                             svt::LoadSaveASCII>  SVMApplicationMini;

int main( int argc, const char** argv)
{
  SVMApplicationMini sa;
  return sa.main( argc, argv, std::cout);
}
