/**************************************************************************
**       Title: svmtl command line application for sparse data
**    $RCSfile: svmtl_sparse.cc,v $
**   $Revision: 1.1 $$Name:  $
**       $Date: 2004/09/09 14:42:22 $
**   Copyright: GPL $Author: ronneber $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: svmtl_sparse.cc,v $
**  Revision 1.1  2004/09/09 14:42:22  ronneber
**  - initial revision
**
**
**
**************************************************************************/

#include <SVMApplication.hh>
#include <SparseFV.hh>
#include <AlgorithmLists.hh>
#include <DefaultMultiClassList.hh>
#include <DefaultTwoClassList.hh>
#include <DefaultOneClassList.hh>
#include <DefaultKernelList.hh>
#include <LoadSaveASCII.hh>

typedef svt::SVMApplication< svt::SparseFV,
                             svt::AlgorithmLists< svt::DefaultMultiClassList, 
                                                  svt::DefaultTwoClassList,
                                                  svt::DefaultOneClassList,
                                                  svt::DefaultKernelList>,
                             svt::LoadSaveASCII>  SVMApplicationSparse;

int main( int argc, const char** argv)
{
  SVMApplicationSparse sa;
  return sa.main( argc, argv, std::cout);
}

